# ChirpStack Tutorial Outline

- Overview
  - RPi gateway + ChirpStack
  - Sensor device
  - Metrics
  - Architecture description
    - Gateway
      - UDP packet forwarder (Semtech) OR concentratord
      - Gateway Bridge OR MQTT Forwarder
      - UDP -> GW Bridge, UDP -> MQTT, or concentratord -> MQTT
    - Server
      - MQTT broker
      - ChirpStack
      - Redis
      - PostgreSQL
    - Integration
      - InfluxDB + Grafana
  - Overall parts and cost
- ChirpStack setup
  - Hardware
    - Raspberry Pi 3 or 4 (+ power supply and MicroSD card)
    - Hat + Seeed WM1302 (SPI version, not USB)
    - Other options
      - [WaveShare](https://www.waveshare.com/sx1302-868m-lorawan-gateway-b.htm?sku=22612)
      - Seeed SenseCAP M2
      - Microtik wAP LR9
      - [Rak WisGate Edge Pro](https://www.choovio.com/product/wisgate-edge-pro-rak7289cv2/)
      - [Milesight UG63](https://www.choovio.com/product/ug63-mini-lorawan-gateway/)
      - [Multitech Conduit AP](https://shop.multitech.com/mtcap2-915-042a-poe.html)
      - [Dragino LPS8N](https://parleylabs.com/lps8n-indoor-lorawan-gateway/)
      - More options
        - <https://www.choovio.com/product-category/lorawan-sensors-gateways-accessories/lora-lorawan-gateway/>
        - <https://www.calchipconnect.com/collections/all-products?gf_43916=215864475815%2B281100910759>
  - Raspberry Pi imaging
    - [RPi imager](https://www.raspberrypi.com/software/); I get it from Flathub with Mint
    - Network setup (static IP, WiFi is fine but prefer ethernet)
  - ChirpStack installation
    - <https://www.chirpstack.io/docs/getting-started/debian-ubuntu.html>
    - Config
  - Packet forwarder
    - Download
    - Config (channel and port settings)
    - Systemd script
  - ChirpStack gateway creation
- Device setup
  - Hardware + tools
    - Wire cutter + 22 AWG wire or premade jump wires
    - Breadboard
    - Makerfocus CubeCell + USB-C to USB-A cable (cannot be USB-C to USB-C!)
    - BME280 temp/pressure/humidity sensor
    - Battery
  - Dev environment
  - Code
    - Loop logic
    - Cayenne LPP overview
  - ChirpStack config
    - Device profile
    - Application
- Metrics setup
  - Diagram overview
  - Cloud instance
  - Docker setup
  - InfluxDB
  - Grafana
  - Nginx
  - Certificates + auto-renewal
  - ChirpStack config

TODO put this somewhere:

There are many more components included in ChirpStack, and they can integrate with one another to allow for lots of flexibility:

```mermaid
flowchart TD
    subgraph Gateway
    pf(Semtech Packet Forwarder) --> gb(ChirpStack Gateway Bridge)
    c(ChirpStack Concentratord) --> uf(ChirpStack UDP Forwarder)
    c --> mf(ChirpStack MQTT Forwarder)
    uf --> gb
    pf --> mf
    end
    mf --> mb
    gb --> mb(Mosquitto MQTT Broker)
    subgraph Cloud Server
    mb--> cs(ChirpStack)
    cs --> i(...Various integrations...)
    end
```
